;======================================================================
    include \masm32\include\masm32rt.inc
    .686
    include \masm32\macros\timers.asm
;======================================================================
    .data
        align 16
        lut LABEL BYTE
        cntr = 0
        REPEAT 256
            .radix 2
            txt TEXTEQU %(cntr)
            .radix 10
            txt2 TEXTEQU <>
            cnt2=@SizeStr(%txt)
            % WHILE cnt2 NE 8
                txt CATSTR <0>,txt
                cnt2=@SizeStr(%txt)
            ENDM
            % FORC chr,<txt>
                txt2 CATSTR <&chr>,txt2
            ENDM
            txt2 TEXTEQU <0>,txt2,<y>
            db txt2
            cntr = cntr + 1
        ENDM
        buff db 40 dup(0)
    .code
;======================================================================
OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
align 4
bitswap_qword proc ddval:DWORD
    mov edx, [esp+4]
    xor eax,eax
    movzx ecx,dl
    mov al,[lut+ecx]
    shl eax,8
    movzx ecx,dh
    shr edx,16
    mov al,[lut+ecx]
    shl eax,8
    movzx ecx,dl
    mov al,[lut+ecx]
    shl eax,8
    movzx ecx,dh
    mov al,[lut+ecx]
    ret 4
bitswap_qword endp
size_qword = $-bitswap_qword+256
OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef
;======================================================================
OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
align 4
bitswap_drizz proc ddval:DWORD
    mov eax, [esp+4]
    bswap eax
    mov edx,00001111000011110000111100001111b
    and edx,eax
    and eax,11110000111100001111000011110000b
    shl edx,4
    shr eax,4
    or eax,edx
    mov edx,00110011001100110011001100110011b
    and edx,eax
    and eax,11001100110011001100110011001100b
    shr eax,2
    lea eax,[edx*4+eax]; shl edx,2; or eax,edx
    mov edx,01010101010101010101010101010101b
    and edx,eax
    and eax,10101010101010101010101010101010b
    shr eax,1
    lea eax,[edx*2+eax]; shl edx,1; or eax,edx
    ret 4
bitswap_drizz endp
size_drizz = $-bitswap_drizz
OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef
;======================================================================
OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
align 4
bitswap_drizznew proc ddval:DWORD
	pop	ecx
    mov	edx,00001111000011110000111100001111b
	pop	eax
	and	edx,eax
    and	eax,11110000111100001111000011110000b
    shl	edx,4
    shr	eax,4
    or		eax,edx
    mov edx,00110011001100110011001100110011b
    and	edx,eax
    and	eax,11001100110011001100110011001100b
    shr	eax,2
    lea	eax,[edx*4+eax]; shl edx,2; or eax,edx
    mov	edx,01010101010101010101010101010101b
    and	edx,eax
    and	eax,10101010101010101010101010101010b
    shr	eax,1
    lea	eax,[edx*2+eax]; shl edx,1; or eax,edx
    bswap eax
	jmp	ecx
bitswap_drizznew endp
size_drizzn = $-bitswap_drizznew
OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef
;======================================================================
dw2bin proc dwNumber:DWORD, pszString:DWORD
    mov eax, dwNumber
    mov ecx, pszString
    sub ecx, 1
    REPEAT 4
        REPEAT 8
            add ecx, 1
            xor edx, edx
            shl eax, 1
            adc edx, '0'
            mov [ecx], dl
        ENDM
        mov BYTE PTR [ecx+1], 32
        add ecx, 1
    ENDM
    mov BYTE PTR [ecx], 0
    ret
dw2bin endp
;======================================================================
start:
;======================================================================

    mov esi, 12345678h

    invoke dw2bin, esi, ADDR buff
    print addr buff,13,10
    invoke bitswap_qword, esi
    invoke dw2bin, eax, ADDR buff
    print addr buff,13,10
    invoke bitswap_drizz, esi
    invoke dw2bin, eax, ADDR buff
    print addr buff,13,10
    invoke bitswap_drizznew, esi
    invoke dw2bin, eax, ADDR buff
    print addr buff,13,10,13,10

    invoke Sleep, 4000

    counter_begin 1000, HIGH_PRIORITY_CLASS
        invoke bitswap_qword, esi
    counter_end
    print ustr$(eax)," cycles, qword 256-byte-lut, "
    print ustr$(size_qword)," bytes",13,10

    counter_begin 1000, HIGH_PRIORITY_CLASS
        invoke bitswap_drizz, esi
    counter_end
    print ustr$(eax)," cycles, drizz stir-fry, "
    print ustr$(size_drizz)," bytes",13,10

    counter_begin 1000, HIGH_PRIORITY_CLASS
        invoke bitswap_drizznew, esi
    counter_end
    print ustr$(eax)," cycles, drizzNew stir-fry, "
    print ustr$(size_drizzn)," bytes",13,10,13,10

    inkey "Press any key to exit..."
    exit
;======================================================================
end start
 